/'

"Force Quit TK22.bas"

Tim Keal's FreeBASIC Force Quit Utility
Copyright 2022 04/24, 2022 07/19 Tim Keal

Released under the Gnu Public License "2.2"
( Attribution, Education / Charity )

Please review the Gnu Public License, Thank you. 
The GPL can be _vga_located online at http://www.gnu.org/copyleft/gpl.html

===

Dev Notes:

This program references ".\Force Quit.dat" as a list of process names to
terminate via a Windows Shell "TaskKill" command.

'/


'Force Quit.bas
'Tim Keal's Force Quit Utility
'Copyright 2022 04/24 0327
'Released under the LGPL "2.2" Attribution, Education / Charity

#lang "fb"

'#include once "file.bi"
'#include once "crt/math.bi"

'#include once "fbgfx.bi"
'#include once "inc/FBImage.bi"

'using Fb.Graphics

declare sub ini()
declare sub main( dat_file as string = "./Force Quit.dat" )
declare sub Force_Quit( app as string = "" )

const _CRLF = chr$( 13 ) & chr$( 10 )
const _QUOT = chr$( 34 )
const _EQ = "="

ini

if len( command$ ) > 0 then
	main command$
else
	main
end if

end

sub ini()

	screenres 320, 240, 8, 6
	screenset 1, 0
	windowtitle "Force Quit"
	
	exit sub
	
end sub

sub main( dat_file as string = "./Force Quit.dat" )

	dim as long filemode = freefile
	if open( dat_file for binary as filemode ) then
		close filemode
		exit sub
	end if

	dim as string buffer = string$( lof( filemode ), 0 )
	get #filemode, 1, buffer
	close #filemode
	
	dim as long o = 1
	dim as string filename = ""
	
	do while o <= len( buffer )
		
		o += len( filename )
		
		select case instr( o, buffer, _CRLF )
		case is > 0
			filename = mid$( buffer, o, instr( o, buffer, _CRLF ) )
		case else
			filename = mid$( buffer, o )
		end select
		
		if len( filename ) > 0 then
			Force_Quit filename
		end if
		
	loop
	
	Force_Quit( "Force Quit" )
	
	exit sub
	
end sub

sub Force_Quit( app as string = "" )
		shell "taskkill -f -im " + _QUOT + app + ".exe" + _QUOT
end sub