@echo off
SETLOCAL EnableDelayedExpansion

set fbc="C:\FreeBASIC\fbc32.exe"
set editor="C:\Program Files (x86)\Notepad++"

set button=[^^!]
set author=Keal
set projectfull=%projectname% %tool%

set _loop_file="%~1"
if "_loop_file"=="" ( exit /b )

call :gen_sequence "50" "="
set bar=%out%

call :gen_sequence "50" "-"
set bar2=%out%

set successflag=[^^! Woot ]
set failureflag=[^^! Oh noes ]
set tracingflag=[^^! Tracing.. ]

set log="%batchpath%%projectfull% Compiler.log"
IF EXIST !log! DEL /F !log!

rem set buildopts=
rem  -asm intel 
set guiopts= -s gui "%batchpath%rc\%projectname%.rc" 
set debugopts=
rem -g 

set /a "_total_bytes=0"
set /a "_total_files=0"

set /a "_in_total_bytes=0"
set /a "_in_total_files=0"

set /a "_out_total_bytes=0"
set /a "_out_total_files=0"

set /a "_in_bad_files=0"
set /a "_out_bad_files=0"

set /a "_del_total_bytes=0"
set /a "_del_total_files=0"
set /a "_del_skipped_files=0"

set Loop=Compilation Sequencer
set Failure=Unprecedented Error

set Binary=Binary Executable
set Static=Static Library
set Dynamic=Dynamic Link Library

set Binary_ext=.exe
set Static_ext=.a
set Dynamic_ext=.dll

set Binary_prefix=
set Static_prefix=lib
set Dynamic_prefix=lib

set libopts=

call :banner
set _incfile="%batchpath%%projectfull%.txt"
call :loop_compile %_incfile% "Loop"

call :summary

call :editor
call :loading

goto :eof

:summary

set /a "_total_bytes=_in_total_bytes+_out_total_bytes"
set /a "_total_files=_in_total_files+_out_total_files"

echo %bar% >> !log!
echo !button! Totals: >> !log!
echo %bar2% >> !log!
echo !button! Inbound   : %_in_total_files% Files / %_in_total_bytes% Bytes >> !log!
echo !button! Skipped   : %_in_bad_files% Files >> !log!
echo %bar2% >> !log!
echo !button! Outbound  : %_out_total_files% Files / %_out_total_bytes% Bytes >> !log!
echo !button! Skipped   : %_out_bad_files% Files >> !log!
echo %bar2% >> !log!
echo !button! Pruned    : %_del_total_files% Files ( %_del_skipped_files% Skipped ) >> !log!
echo !button! Collective: %_total_files% Files / %_total_bytes% Bytes >> !log!

exit /b

:caption
echo %bar% >> !log!
echo !button! %~1 ( !%~2! ) >> !log!
echo %bar% >> !log!
rem rem pause >nul
exit /b

:loading
%projectfull%.exe >> !log!
rem rem pause >nul
exit /b

:editor
%editor% !log!
rem rem pause >nul
exit /b

:banner

set datetime=%DATE% %TIME%
echo !button! %datetime% >> !log!

echo %bar% >> !log!

set projectname1=%author%'s
set projectname2=%projectfull%
set projectname3=Batch Compiler Utility

set pn1=%projectname1%
set pn2=%projectname2%
set pn3=%projectname3%

call :gen_sequence "8" " "
set ws=%out%

set pn1=%ws%%pn1%
set pn2=%ws%%pn2%
set pn3=%ws%%pn3%

echo %pn1:~-50% >> !log!
echo %pn2:~-50% >> !log!
echo %pn3:~-50% >> !log!

echo %bar% >> !log!

rem rem pause >nul
exit /b

:full_compile

set _full_name=%~1
set _type=%~2
call :caption "%~1" "%_type%"
rem call :file_parts "%~1"
call :parts "%_full_name%" "%_type%"

if "%_type%"=="Loop" (
	call :loop_compile "%~1"
)

if "%_type%"=="Binary" (
	call :binary_prune "%~1"
	call :binary_compile "%~1"
)

if "%_type%"=="Static" (
	call :static_prune "%~1"
	call :static_compile "%~1"
)

if "%_type%"=="Dynamic" (
	call :dynamic_prune "%~1"
	call :dynamic_compile "%~1"
)

call :inbound_trace "%~1"
call :outbound_trace "%~1"

exit /b

:loop_compile
set filename=%_loop_file%
set type=%~2
call :caption "%filename%" Loop
for /F "usebackq tokens=*" %%A in (%filename%) do ( if "%%A"=="" ( exit /b ) else ( call :full_compile %%A ) )
exit /b

:binary_prune
call :file_about "%~1"

if exist "%_file_name%.exe" (
	echo !button! Now Pruning: "%_file_name%.exe" >> !log! 2>&1
	echo %bar2% >> !log!

	del "%_file_name%.exe"
	
	if "%errorlevel%"=="1" (
		set /a "_del_skipped_files=_del_skipped_files+1"
	) else (
		set /a "_del_total_files=_del_total_files+1"
	)
) else (
	set /a "_del_skipped_files=_del_skipped_files+1"
)
exit /b

:binary_compile
call :file_about "%~1"

echo !button! Now Compiling: "%_file_name%.exe" >> !log! 2>&1
echo %bar2% >> !log!

set command=-x "%_file_name%.exe" "%~1" %debugopts% %fbopts% %guiopts% %libopts%
echo %fbc% %command% >>!log! 2>&1
@echo on
%fbc% %command% >>!log! 2>&1
@echo off
echo %bar% >> !log!
if "%errorlevel%"=="1" (call :binary_failure "%_full_name%") else (call :binary_success "%_full_name%")
exit /b

:static_prune
call :file_about "%~1"

if exist "lib%_file_name%.a" (
	echo !button! Now Pruning: "lib%_file_name%.a" >> !log! 2>&1
	echo %bar2% >> !log!

	del "lib%_file_name%.a"
	
	if "%errorlevel%"=="1" (
		set /a "_del_skipped_files=_del_skipped_files+1"
	) else (
		set /a "_del_total_files=_del_total_files+1"
	)
) else (
	set /a "_del_skipped_files=_del_skipped_files+1"
)
exit /b

:static_compile
call :file_about "%~1"

echo !button! Now Compiling: "lib%_file_name%.a" >> !log! 2>&1
echo %bar2% >> !log!

set command="%~1" -lib %debugopts% %fbopts%
echo %fbc% %command% >>!log! 2>&1
@echo on
%fbc% %command% >>!log! 2>&1
@echo off
echo %bar% >> !log!
if "%errorlevel%"=="1" (call :static_failure "%_full_name%") else (call :static_success "%_full_name%")
call :file_parts "%~1"
set libopts=%libopts% -include ".\inc\%_file_name%.bi"
exit /b

:dynamic_prune
call :file_about "%~1"

if exist "lib%_file_name%.dll" (
	echo !button! Now Pruning: "lib%_file_name%.dll" >> !log! 2>&1
	echo %bar2% >> !log!
	
	del "lib%_file_name%.dll"
	
	if "%errorlevel%"=="1" (
		set /a "_del_skipped_files=_del_skipped_files+1"
	) else (
		set /a "_del_total_files=_del_total_files+1"
	)
) else (
	set /a "_del_skipped_files=_del_skipped_files+1"
)
exit /b

:dynamic_compile
call :file_about "%~1"

echo !button! Now Compiling: "lib%_file_name%.dll" >> !log! 2>&1
echo %bar2% >> !log!

set command="%~1" -dll %debugopts% %fbopts%
echo %fbc% %command% >>!log! 2>&1
@echo on
%fbc% %command% >>!log! 2>&1
@echo off
echo %bar% >> !log!
if "%errorlevel%"=="1" (call :dynamic_failure "%_full_name%") else (call :dynamic_success "%_full_name%")
exit /b

:binary_success
call :file_about "%~1"
call :validate_size "%~1"
set _file_prefix2=
set _file_extension2=.exe
call :validate_size "%_file_prefix2%%_file_name%%_file_extension2%"
exit /b

:static_success
call :file_about "%~1"
call :validate_size "%~1"
set _file_prefix2=lib
set _file_extension2=.a
call :validate_size "%_file_prefix2%%_file_name%%_file_extension2%"
exit /b

:dynamic_success
call :file_about "%~1"
call :validate_size "%~1"
set _file_prefix2=
set _file_extension2=.dll
call :validate_size "%_file_prefix2%%_file_name%%_file_extension2%"
exit /b

:binary_failure
set _type=%Binary%
call :file_about "%~1"
echo !button! [!_type! Failure] >> !log!
echo %bar2% >> !log!
echo !failureflag! %_type% ^"%_full_name%^" >> !log!
echo !button! ( failed to compile ) >> !log!
echo %bar2% >> !log!
set _file_prefix2=
set _file_extension2=.exe
call :validate_size "%~1"
rem pause >nul
call :errorticker
exit /b

:static_failure
set _type=%Static%
call :file_about "%~1"
echo !button! [!_type! Failure] >> !log!
echo %bar2% >> !log!
echo !failureflag! %_type% ^"%_full_name%^" >> !log!
echo !button! ( failed to compile ) >> !log!
echo %bar2% >> !log!
set _file_prefix2=lib
set _file_extension2=.a
call :validate_size "%~1"
rem pause >nul
call :errorticker
exit /b

:dynamic_failure
set _type=%Dynamic%
call :file_about "%~1"
echo !button! [!_type! Failure] >> !log!
echo %bar2% >> !log!
echo !failureflag! %_type% ^"%_full_name%^" >> !log!
echo !button! ( failed to compile ) >> !log!
echo %bar2% >> !log!
set _file_prefix2=
set _file_extension2=.dll
call :validate_size "%~1"
rem pause >nul
call :errorticker
exit /b

:inbound_trace

call :file_about "%~1"

echo %bar% >> !log!

echo !button! Inbound Trace >> !log!
echo %bar2% >> !log!

echo !tracingflag! full name: "%_file_name%%_file_extension%" >> !log!
echo !tracingflag! file name: "%_file_name%" >> !log!
echo !tracingflag! extension: "%_file_extension%" >> !log!
call :file_size "%_file_name%%_file_extension%"
echo !tracingflag! file size: %_file_size% >> !log!
call :file_datetime "%_file_name%%_file_extension%"
echo !tracingflag! date/time: %_file_datetime% >> !log!

if "%_file_size%"=="n/a" ( set /a "_in_bad_files=_in_bad_files+1" ) else ( set /a "_in_total_files=_in_total_files+1" )
set /a "_in_total_bytes=_in_total_bytes+_file_size"

exit /b

:outbound_trace

call :file_about "%_file_prefix2%%_file_name%%_file_extension2%"

echo %bar% >> !log!

echo !button! Outbound Trace >> !log!
echo %bar2% >> !log!

echo !tracingflag! full name: "%_file_name%%_file_extension%" >> !log!
echo !tracingflag! file name: "%_file_name%" >> !log!
echo !tracingflag! extension: "%_file_extension%" >> !log!
call :file_size "%_file_name%%_file_extension%"
echo !tracingflag! file size: %_file_size% >> !log!
call :file_datetime "%_file_name%%_file_extension%"
echo !tracingflag! date/time: %_file_datetime% >> !log!

if "%_file_size%"=="n/a" ( set /a "_out_bad_files=_out_bad_files+1" ) else ( set /a "_out_total_files=_out_total_files+1" )
set /a "_out_total_bytes=_out_total_bytes+_file_size"

exit /b

:file_about
set _full_name=%~1
call :file_parts "%~1"
call :file_size "%~1"
call :file_datetime "%~1"
exit /b

:file_parts
set _file_name=%~n1
set _file_extension=%~x1
exit /b

:file_size
if not exist "%~1" ( set "_file_size=n/a" )
if "%_file_size%"=="n/a" ( exit /b )
set /a "_file_size=0"
for %%I in ("%~1") do ( set /a "_file_size=_file_size+%%~zI" )
set "_file_size=%_file_size% Bytes"
exit /b

:file_datetime
set "_file_datetime=n/a"
for %%A in ("%~1") do ( set "_file_datetime=%%~tA" )
if "%_file_datetime%"=="" ( set "_file_datetime=n/a" )
exit /b

:validate_size
call :file_about "%~1"
if "%_file_size%"=="0" ( call :validate_failure "%~1" )
if "%_file_size%"=="n/a" ( call :validate_failure "%~1" )
if "%_file_size%"=="0" ( exit /b )
if "%_file_size%"=="n/a" ( exit /b )
call :validate_success "%~1"
exit /b

:validate_success
echo !successflag! >> !log!
echo !button! ^( "%~1" contains !_file_size! ^) >> !log!
echo %bar% >> !log!
exit /b

:validate_failure
echo !failureflag! >> !log!
if not exist "%~1" ( goto :not_exist ) else ( goto :is_empty )
echo %bar% >> !log!
exit /b

:not_exist
echo !button! ^( "%~1" doesn't exist ^) >> !log!
echo %bar% >> !log!
exit /b

:is_empty
echo !button! ^( "%~1" is an empty file ^) >> !log!
echo %bar% >> !log!
call :errorticker
exit /b

:gen_sequence
SET "out="
for /L %%i in (0,1,%~1) do (
    SET "out=!out!%~2"
)
exit /b

:errorticker
if "%_errorcount%"=="" ( set /a "_errorcount=0" )
set /a "_errorcount=__errorcount+1" )
exit /b

:parts
	call :in_filename %~1
	set o_filename=%i_filename%
	call :out_mode "%~2"
	call :out_suffix %_mode%
	call :out_prefix %_mode%
exit /b

:in_filename
	set i_filename=%~n1
	set i_suffix=%~x1
exit /b

:out_mode
	set _mode=
	if "%_type%"=="Binary Executable" (
		set _mode=%~1
	)
	if "%_type%"=="Static Library" (
		set _mode=%~1
	)
	if "%_type%"=="Dynamic Link Library" (
		set _mode=%~1
	)
exit /b

:out_suffix
	if "%_type%"=="Binary Executable" (
		set o_suffix=.exe
	)
	if "%_type%%"=="Static Library" (
		set o_suffix=.a
	)
	if "%_type%"=="Dynamic Link Library" (
		set o_suffix=.dll
	)
exit /b

:out_prefix
	if "%_type%"=="Binary Executable" (
		set o_prefix=
	)
	if "%_type%"=="Static Library" (
		set o_prefix=lib
	)
	if "%_type%"=="Dynamic Link Library" (
		set o_prefix=lib
	)
exit /b